// 
// The following function product(a) returns the product of all  numbers in
// array a.

function product(a: array<int>): int
    requires a!=null;
    reads a;
{
  productAux(a,0,a.Length-1) 
}

// It is defined in terms of the auxiliary function productAux(a,from,to),
// which returns the product of all  numbers in array a between (and including)
// from and to. It calculates the product starting from the rightmost index of
// the interval [from..to].

function productAux(a: array<int>, from:nat, to:int): int
    requires a!=null && to < a.Length; 
    reads a;
    decreases to-from;
{
  if ( from > to )
    then 1
  else if ( from==to )
    then a[to] 
    else productAux(a,from,to-1) * a[to] 
}

// The same mathematical function may be defined in terms of the alternative
// auxiliary function productAuxAlt(a,from,to), which also returns the product
// of all  numbers in array a between (and including) from and to, but
// calculates the product starting from the left-most index of the interval
// [from..to].

function productAuxAlt(a: array<int>, from:nat, to:int): int
  requires a!=null && to < a.Length; 
  reads a;
   decreases to-from;
{
  if ( from > to )
    then 1
  else if ( from==to )
    then a[to] 
    else a[from] * productAuxAlt(a,from+1,to)   
}

// ******************************  Question 1 **************************************
// Question 1
// State and prove a Lemma in Dafny, which ascertains that
// productAux(a,from,to) returns the same result as productAuxAlt(a,from,to).

ghost method Lemma(a: array<int>, from:nat, to:int)
   requires ???;
   ensures productAux(a,from,to) == (a,from,to);
   decreases ???;
 { if (from>to)  {   }
   else { if (from==to) { }
          else {assume false; } }
 }


//
// ******************************  Question 2 **************************************
// 
// Consider now an alternative definition, which calculates the product of all
// number in an array a, by traversing the array right-to-left. 
// Prove that the method above satisfies its specification. 

method ProductAlt(a: array<int>) returns (p: int)
  requires a != null;
  ensures p == product(a);
{
  var i := a.Length-1;
  p := 1;

  while (i >= 0)
    invariant ??? use productAuxAlt instead of productAux;
  {
    p := p * a[i];
    i := i - 1;
  }

  // notice that we call the lemma here
  Lemma(a,0,a.Length-1);
 
}
